# Brett Bates

class P4GTD

    attr_accessor :vars

    def initialize
        # Read in STDIN to a hash
        @vars = Hash.new
        $stdin.each_line do
            |line|
            if( line =~ /(\w+):\s+(.*)/ )
                @vars[ $1 ] = $2
            end
        end

        p "here"
        p @vars['Arg0']

        comm = command_switch

        bool, msg = comm.run

        send_answer(bool, msg)        

    end

    # Find the correct module to run
    def command_switch

        case @vars['Arg0'].downcase
            when "alarm"
                comm = GTDAlarm.new(arg_hash_to_list)
            when "note"
                comm = GTDNote.new(arg_hash_to_list)
        end

        return comm

    end

    # Take the @vars hash and turn the arguments at the end into a list
    def arg_hash_to_list

        arg_list = []

        for x in 0...(@vars['argCount'] - 1)
            arg_list << @vars['Arg' + x]
        end

        return arg_list
        
    end

    # Send the finishing message to the broker
    #
    # bool: If true send PASS else REJECT
    # msg: the message to accompany the action
    def send_answer(bool, msg = "null")
        if !bool
            puts "action: REJECT"
            puts "message: #{msg}"
        else
            puts "action: RESPOND"
            puts "message: #{msg}"
        end
    end

end

gtd = P4GTD.new
